SystemOrganization addCategory: #'Pier-Setup'!

Object subclass: #PRDistribution
	instanceVariableNames: 'blog contentsWidget environmentPage metaEnvironmentPage breadcrumbWidget commandsPage googleAnalyticsWidget siteTitlePage sitemapPage stylesheetFile systemManagementPage viewsPage menuWidget loginCommandWidget mainEnvironmentPage childrenWidget postTickerWidget rootPage kernel syntaxPage aboutPage blogArchiveWidget blogEnvironmentPage poweredByPage searchWidget headerPage footerPage shortcutsPage loggedInUserPage designChooserWidget fileSettingsWidget documentWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PRDistribution class methodsFor: 'accessing' stamp: 'tg 2/18/2009 23:30'!
title
	"override this method to name the design"
	^'Default'! !

!PRDistribution class methodsFor: 'accessing' stamp: 'tg 7/10/2009 17:09'!
update
	PRLoader load.! !

!PRDistribution class methodsFor: 'accessing' stamp: 'tg 2/18/2009 15:42'!
workspaceText

	^
'"----------PIER-----------
Pier is already running at:
http://localhost:8080/seaside/pier

The Seaside server administration interface can be reached at: 
http://localhost:8080/seaside/config

The default username/password for Pier is admin/pier.
The default username/password for Seaside admin/seaside.

For more information about Pier check:
http://www.piercms.com
-------------------------"

"Web server management"
WAKomEncoded startOn: 8080.
WAKomEncoded stop.

"Memory cleanup"
WARegistry clearAllHandlers.
MCFileBasedRepository flushAllCaches.
Smalltalk garbageCollect.

"In memory persistency (default)"
PRKernel instances anyOne persistency: PRHistoryPersistency new.

"Image persistency (save up to 3 images and in 30 mins after a change)"
PRKernel instances anyOne persistency: (PRImagePersistency new 
											duration: 30 minutes;
											maxImages: 3).
			
"Reset all Pier settings to the original ones"
PRDistribution new register.

"Useful shortcuts"
PRKernel instances anyOne root.'! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 10/9/2008 09:56'!
aboutPage
	^ aboutPage ifNil: [
		aboutPage := (PRPage named: 'about')
					title: 'About Pier';
					contents:
'*Pier>http://www.piercms.com* is a content management system that aims at allowing users to manage their content from the browser.

The central concept in Pier is the one of Structure. For example, the current page is a structure. The */blog* is also a structure, but it is slightly different than a page. A file is also a structure.

Commands can be executed on a Structure. For example, a Structure can be edited. In the current setup you can edit this site after logging in (the commands appear in the footer). Once in edit mode, you can use the *syntax*. To make life easier, Pier also offers access to these commands via *shortcuts>http://www.piercms.com/doc/shortcuts*.

Any Structure can be Viewed. The default View is the one that renders the structure for normal usage. Another example, is the Browse View which offers a file system like view on the Pier structures.

Any Structure has an environment which defines the template. For example, the environment of this page is */environment* (you have to be logged in to see it). To set the environment to be a different page use the Settings command. To edit the environment use the Edit Design command.

A Structure can contain Widgets. For example, the environment of this page contains a menu widget on top, and a widget that enumerates the children of the current sturcture to the right.

More about Pier can be found at: *http://www.piercms.com*.'
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:15'!
blog
	^ blog ifNil: [
		blog := (PBBlog named: 'blog')
		addChild: (
			(PBPost named: 'downtobusiness')
			title: 'Down to business';
			contents: 'I like blogging, so here is my second post.';
			publication: TimeStamp now;
			addChild: ((PBComment named: '1')
				contents: 'We are glad to see that you get serious about blogging. Btw, this is a comment.';
				author: 'The Pier Team';
				website: 'http://www.piercms.com';
				yourself
				);
			yourself
		);
		addChild: (
			(PBPost named: 'hello')
			title: 'Hello';
			contents: 'Hi!! This is my first post.';
			publication: TimeStamp today;
			yourself
		);
		yourself
	].
! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:00'!
blogArchiveWidget
	^ blogArchiveWidget ifNil: [
		blogArchiveWidget := (PRComponent named: 'blogarchive')
		title: 'Blog Archive';
		componentClass: PBPostArchive;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 7/11/2009 01:28'!
blogEnvironmentPage
	^ blogEnvironmentPage ifNil: [
		blogEnvironmentPage := (PRPage named: 'blogenvironment')
		title: '_Blog Environment';
		contents: 
'<div class="container">
	+/environment/header+
	<div class="column span-24 last mainbody">
		<h1 class="heading">+>value:structure|level=2+</h1>
		<h1>+>value:structure|level=0|lower=3+</h1>
		<div class="column span-12 contents">
			+/environment/contents+
		</div>
		<div class="column span-6 prepend-6 last sidebar">
			<h2>Archive</h2>
			+/environment/blogarchive+
		</div>
	</div>
	+/environment/footer+
</div>
+/environment/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:24'!
breadcrumbWidget
	^ breadcrumbWidget ifNil: [breadcrumbWidget := (PRComponent named: 'breadcrumb')
		componentClass: PRBreadcrumbWidget;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:25'!
childrenWidget
	^ childrenWidget ifNil: [childrenWidget := (PRComponent named: 'children')
		componentClass: PRChildrenWidget;
		write: 2
			using: PRChildrenWidget descriptionLevel;
		write: true
			using: PRChildrenWidget descriptionExpand;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:01'!
commandsPage
	^ commandsPage ifNil: [
		commandsPage := (PRPage named: 'commands') 
		addChild: ((PRComponent named: 'widget') componentClass: PRCommandsWidget; yourself);
		contents: 'Commands: +widget+';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/5/2009 00:01'!
contentsWidget
	^ contentsWidget ifNil: [
		contentsWidget := (PRComponent named: 'contents')
		componentClass: PRContentsWidget;
		write: '' using: PRContentsWidget descriptionHeading;
		yourself
	].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/18/2009 23:39'!
designChooserWidget
	^ designChooserWidget ifNil: [designChooserWidget := (PRComponent named: 'designchooser')
		componentClass: PRDesignChooserWidget;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'onierstrasz 4/17/2009 11:44'!
documentWidget
	^ documentWidget ifNil: [
		documentWidget := (PRComponent named: 'sidebar')
		title: 'Sidebar Document';
		componentClass: PRDocumentWidget;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 7/11/2009 01:19'!
environmentPage
	^ environmentPage ifNil: [
		environmentPage := (PRPage named: 'environment')
		title: '_Environment';
		contents: 
'<div class="container">
	+/environment/header+
	<div class="column span-24 last mainbody">
		<h1 class="heading">+>value:structure|level=2+</h1>
		<h1>+>value:structure|level=0|lower=3+</h1>
		<div class="column span-12 contents">
			+/environment/contents+
		</div>
		<div class="column span-6 prepend-6 last sidebar">
			<h2>Navigation</h2>
			+/environment/children+
		</div>
	</div>
	+/environment/footer+
</div>
+/environment/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/1/2009 15:08'!
footerPage
	^ footerPage ifNil: [
		footerPage := (PRPage named: 'footer')
		contents:
'<div class="footer column span-24 last">
	<div class="column span-18">
		+/environment/justlogincommand+
		+/environment/loggedinuser+
		<div class="commands">+/environment/commands+</div>
		<div class="views">+/environment/views+</div>
		<div class="sitemap">+/environment/sitemap+</div>
	</div>
	<div class="column span-6 last">+/environment/poweredby+</div>
</div>
';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:27'!
googleAnalyticsWidget
	^ googleAnalyticsWidget ifNil: [ 
		googleAnalyticsWidget := (PRComponent named: 'googleanalytics')
		title: 'Google Analytics';
		componentClass: PRGoogleAnalyticsWidget
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 4/4/2009 16:00'!
headerPage
	^ headerPage ifNil: [
		headerPage := (PRPage named: 'header')
		contents:
'<div class="column span-24 last header">
	<div class="menu">+/environment/menu|menu+</div>
</div>';
		yourself
	]! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 9/6/2008 18:46'!
kernel
	^ kernel ifNil: [
		kernel := PRKernel named: 'pier'.
		kernel root: self root.
		kernel
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/1/2009 15:09'!
loggedInUserPage
	^ loggedInUserPage ifNil: [
		loggedInUserPage := (PRPage named: 'loggedinuser') 
		addChild: ((PRComponent named: 'widget') componentClass: PUSecurityWidget; yourself);
		contents: 'Logged in as +value:user+ (+widget+?)';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/8/2008 15:58'!
loginCommandWidget
	^ loginCommandWidget ifNil: [
		loginCommandWidget := (PRComponent named: 'justlogincommand')
		title: 'Just Login Command';
		componentClass: PRCommandsWidget;
		write: (Array with: PULogin) using: PRCommandsWidget descriptionCommandClasses ;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'onierstrasz 4/17/2009 11:43'!
mainEnvironmentPage
	^ mainEnvironmentPage ifNil: [
		mainEnvironmentPage := (PRPage named: 'mainenvironment')
		title: '_Main Environment';
		contents: 
'<div class="container">
	+/environment/header+
	<div class="column span-24 last mainbody">
		<h1 class="heading">+value:structure+</h1>
		<div class="contents column span-12">+/environment/contents+</div>
		<div class="postticker column prepend-6 span-6 last">
			<h2>What''s new</h2>
			+/environment/postticker+
			+/environment/sidebar+
		</div>
	</div>
	+/environment/footer+
</div>
+/environment/googleanalytics+
';
		yourself
	]! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:52'!
makePrivate: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'rights' stamp: 'tg 9/5/2008 22:59'!
makePublic: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 4/4/2009 15:58'!
menuPage
	^ menuWidget ifNil: 
		[ menuWidget := (PRPage named: 'menu')
			contents:
'- *Home>/*
- *Blog>/blog*
- *About>/about*';
			yourself ]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:29'!
metaEnvironmentPage
	^ metaEnvironmentPage ifNil: [
		metaEnvironmentPage := (PRPage named: 'metaenvironment')
		title: '_Meta Environment';
		hideFromMenus: true;
		contents: '<div class="container metaenvironment">
	<div class="span-24 last metaheader">
		Meta page: +/environment/breadcrumb+
	</div>
	<div class="span-24 last">
		+/environment/contents+
	</div>
	<div class="span-24 last metafooter">
		<div class="span-10">+/environment/commands+</div>
		<div class="span-10 last">+/environment/sitemap+</div>
	</div>

</div>';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:30'!
postTickerWidget
	^ postTickerWidget ifNil: [
		postTickerWidget := (PRComponent named: 'postticker')
		title: 'Post Ticker';
		componentClass: PBPostTicker;
		write: blog using: PBPostTicker descriptionBlog;
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 14:42'!
poweredPage
	^ poweredByPage ifNil: [poweredByPage := (PRPage named: 'poweredby')
		title: 'Powered By';
		contents: 
'Powered by *Pier>http://www.piercms.com*';
		yourself
	]! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 2/19/2009 08:55'!
register 
	WAKom withAllSubclasses do: [:each | each stop].
	PRKernel reset.
	PRPierFrame 
		registerAsApplication: 'pier'
		kernel: self kernel.
	WAKomEncoded startOn: 8080.! !

!PRDistribution methodsFor: 'creation' stamp: 'tg 2/19/2009 00:17'!
replaceRoot
	kernel := PRKernel instances anyOne.
	kernel root: self root! !

!PRDistribution methodsFor: 'creation' stamp: 'onierstrasz 4/17/2009 11:44'!
root
	self rootPage
		addChild: self blog;
		addChild: (self aboutPage
				addChild: self syntaxPage;
				yourself);
		addChild: (self environmentPage
				addChild: self headerPage;
				addChild: self siteTitlePage;
				addChild: self footerPage;
				addChild: self menuPage;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self postTickerWidget;
				addChild: self blogArchiveWidget;
				addChild: self searchWidget;
				addChild: self poweredPage;
				addChild: self loggedInUserPage;
				addChild: self designChooserWidget;
				addChild: self documentWidget;
				yourself);
		addChild: self blogEnvironmentPage;
		addChild: self mainEnvironmentPage;
		addChild: self metaEnvironmentPage;
		addChild: self systemManagementPage.
	self rootPage localEnvironment: self mainEnvironmentPage.
	self blog localEnvironment: self blogEnvironmentPage.
	self aboutPage localEnvironment: self environmentPage.
	self environmentPage localEnvironment: self metaEnvironmentPage.
	self mainEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self systemManagementPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	self rootPage enumerator
		with;
		all;
		do: 
			[ :each | 
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self environmentPage.
	self makePrivate: self blogEnvironmentPage.
	self makePrivate: self mainEnvironmentPage.
	self makePrivate: self metaEnvironmentPage.
	self makePrivate: self sitemapPage.
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	self makePrivate: self loggedInUserPage.
	^ self rootPage! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/18/2009 23:35'!
rootPage
	^ rootPage ifNil: [
		rootPage := (PRPage named: 'pier')
		title: 'Welcome to Pier!!';
		yourself.

		rootPage 
		contents:
'This is the main page of the official Pier distribution. Before you can modify this site, you have to login using: admin/pier.

If you are not satisfied with the current look, perhaps you want to choose another one:

+/environment/designchooser+

Have fun,<br></br>
The Pier Team
'.
		rootPage]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 09:13'!
searchWidget
	^ searchWidget ifNil: [
		searchWidget := (PRComponent named: 'search')
		componentClass: PRAjaxSearchWidget;
		write: ( PRStructure withAllConcreteClasses reject: [:each | each = PRPage or: [each = PBPost]] ) using: PRAjaxSearchWidget descriptionFilter ;
		yourself
	].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/17/2008 00:11'!
siteTitlePage
	^ siteTitlePage ifNil: [
		siteTitlePage := (PRPage named: 'sitetitle')
		title: 'Site Title';
		contents: '!!*Your Pier>/*';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/13/2008 19:02'!
sitemapPage
	^ sitemapPage ifNil: [
		sitemapPage := (PRPage named: 'sitemap')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRTreeWidget;
				yourself);
		contents:
'Sitemap
+widget+'
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 7/10/2009 15:59'!
stylesheetFile
	^ stylesheetFile ifNil: [
		stylesheetFile := (PRFile named: 'defaultCss')
		filename: 'style.css';
		mimetype: 'text/css';
		contents: 
'/* HEADER */
.icon a {outline: none; background: white;}
.search input.text {
	border: 1px solid white;
	color: black;}
.search input.text:focus {
	border: 1px solid #ff6633;
	color: black;}
.search input {
	color: #ff6633;
	font-size: 1em;
	outline: none;
	width: 98%;
	border: 0;
	margin-top: 0.1em;
	padding: 0.3em;
	padding-top: 0;
	background: 0;}
.search ul {
	margin: 0;
	padding: 0;
	background: white;
	list-style-type: none;
	border: 1px solid #ff6633;
	border-top: 0;}
.search li.selected a {color: #fff;}
.search li.selected {
	background-color: #ff6633;
	color: white;}
.search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;}
.menu ul {
	margin: 0;
	margin-top: 0.2em;
	padding-bottom: 0.2em;
	list-style-type: none;}
.menu ul li {
	display: inline;
	margin: 0;
	margin-right: 1.5em;
	list-style-type: none;}
.menu li a {
	padding-left: 0.3em;
	padding-right: 0.3em;
	padding-top: 0.5em;
	padding-bottom: 0.3em;}


/*BLOG*/
div.post {margin-bottom: 4.5em;}
div.comment {margin-bottom: 3em;}
.meta {font-size: 80%; color: #aaa;}
.leavecomment {margin-top: 4.5em; margin-bottom: 4.5em;}
.comments {margin-top: 4.5em;}


/* NAVIGATION */
.sidebar ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.sidebar ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.sidebar ul li {
	margin-top: 1.5em;}
.sidebar ul li a {
	padding-left: 0.3em;
	padding-right: 0.3em;
	padding-top: 0.3em;
	padding-bottom: 0.3em;}
.sidebar p,
.sidebar h1, .sidebar h2, .sidebar h3,
.sidebar .postticker .timestamp,
.sidebar .postticker .summary {padding-left: 0.3em;}
.sidebar .active,
.menu li a.active {
	color: white;
	background: #ff6633;}


/*MAIN BODY*/
.mainbody {
	padding-top: 4em;
	padding-bottom: 15em;}
.postticker ul {
	font-size: 80%;
	color: #aaa;
	list-style: none;
	margin-left: 0;}
.postticker ul li {
	margin-bottom: 1.5em;}
.postticker .timestamp {color: #aaa; font-size: 80%;}
.postticker .subscribe,
.postticker .timestamp .time,
.postticker .timestamp .author {display: none;}
.postticker a.post {color: #aaa;}


/* FOOTER */
.footer {
	color: #aaa;
	font-size: 80%;
	text-align: left;}
.footer a { color: #aaa;}
.footer ul {list-style: none; margin-left: 0em;}
.footer ul ul {margin-left: 1.5em;}
.footer .commands ul, .footer .views ul {display: inline;}
.footer .commands ul li, .footer .views ul li {display: inline; padding-right: 1em;}


/* META */
.metaenvironment h1.heading {display: none;}
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}


/*DEFAULT*/
body {margin-top: 0;}
h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: inherit; }
h1.heading { font-size: 2em; margin-bottom: 1.5em; }
h1 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
.maincontents {font-size: 1.5em;}
h2 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h3 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h4 { font-size: 1em; font-weight: bold; }
h5 { font-size: 1em; }
textarea {width: 100%;}
input.text, input.password {width: 200px;}
input[type="button"], input[type="submit"], input[type="reset"], input[type="file"], button { margin-left: 0.5em;} 


/* PIER */
.broken { color: red; font-weight: bold;}
.protected { color: #aaa; }
a {color: #ff6633;}
a:hover {
	color: white;
	background: #ff6633; }
a:hover.nobackground {background: white;}
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}
.right {text-align: right;}
.left {text-align: left;}
.center {text-align: center;}
.float {float: right;}
.nobullets ul {list-style: none; margin-left: 0;}
.nobullets ul li {list-style: none; margin-left: 0;}
tr th {background: #eee; font-weight: normal;}
label {font-weight: normal;}
tr.group th {background: white; font-size: 1em; font-weight: bold; margin-top: 1.5em; }
td.required:after {color: #ff6633; content: "*"; margin-left: 0.5em;}
';
		yourself]! !

!PRDistribution methodsFor: 'structures' stamp: 'damiencassou 1/21/2009 18:48'!
syntaxPage
	^ syntaxPage ifNil: [
		syntaxPage := PRKernel defaultInfoSyntax].! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 2/28/2009 20:01'!
systemManagementPage
	^ systemManagementPage ifNil: [
		systemManagementPage := (PRPage named: 'systemmanagement')
		title: '_System Management';
		addChild: ((PRComponent named: 'users')
				componentClass: PUUsersWidget;
				yourself);
		addChild: ((PRComponent named: 'groups')
				componentClass: PUGroupsWidget;
				yourself);
		addChild: ((PRComponent named: 'persistency')
				componentClass: PRPersistencySettings;
				yourself);
		addChild: ((PRComponent named: 'kernel')
				componentClass: PRKernelSettings;
				yourself);
		addChild: ((PRComponent named: 'file')
				componentClass: PRFileSettings;
				yourself);
		contents: '!!Users
+users+

!!User Group
+groups+

!!Persistency
+persistency+

!!Kernel Settings
+kernel+

!!File Settings
+file+';
		yourself
	]! !

!PRDistribution methodsFor: 'structures' stamp: 'tg 9/6/2008 18:33'!
viewsPage
	^ viewsPage ifNil: [
		viewsPage := (PRPage named: 'views')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRViewsWidget;
				yourself);
		contents: 'Views: +widget+'
	]! !

PRDistribution subclass: #PREventDistribution
	instanceVariableNames: 'eventTitlePage callPage pcPage datesPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PREventDistribution class methodsFor: 'as yet unclassified' stamp: 'tg 2/18/2009 23:30'!
title
	^ 'Event'! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 2/22/2009 22:23'!
blog
	^ blog ifNil: [
		blog := (PBBlog named: 'news')
		addChild: (
			(PBPost named: 'online')
			title: 'Online';
			contents: 'The page is online. Stay tuned for more news.';
			publication: TimeStamp today;
			yourself
		);
		yourself
	].
! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 2/19/2009 00:45'!
callPage
	^ callPage ifNil: 
		[ callPage := (PRPage named: 'call')
			title: 'Call for Contributions';
			contents: 'TBA';
			yourself ]! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 2/19/2009 01:01'!
datesPage
	^ datesPage ifNil: 
		[ datesPage := (PRPage named: 'dates')
			title: 'Important Dates';
			contents: 'TBA';
			yourself ]! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 4/4/2009 16:05'!
environmentPage
	^ environmentPage ifNil: [
		environmentPage := (PRPage named: 'environment')
		title: '_Environment';
		contents: 
'<div class="header">
	<div class="container">
		<div class="eventTitle">+/environment/eventtitle+</div>
		<div class="menu">+/environment/menu|menu+</div>
	</div>
</div>
<div class="container">
	<div class="column span-24 last mainbody">
		<h1>+value:structure+</h1>
		<div class="column span-12 contents">
			+/environment/contents+
		</div>
		<div class="column span-6 prepend-6 last sidebar">
			<h2>What''s new</h2>
			<div class="postticker">+/environment/postticker+</div>
		</div>
	</div>
	+/environment/footer+
</div>
+/environment/googleanalytics+
';
		yourself
	]! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 2/19/2009 00:40'!
eventTitlePage
	^ eventTitlePage ifNil: 
		[ eventTitlePage := (PRPage named: 'eventtitle')
			title: 'Event Title';
			contents: '
			<h1 class="heading">Event</h1>
			<h2>Location</h2>
			';
			yourself ]! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 4/4/2009 16:04'!
menuPage
	^ menuWidget ifNil: 
		[ menuWidget := (PRPage named: 'menu')
			contents:
'- *Home>/*
- */call*
- */pc*
- */dates*
- */news*';
			yourself ]! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 2/19/2009 00:45'!
pcPage
	^ pcPage ifNil: 
		[ pcPage := (PRPage named: 'pc')
			title: 'Program Committee';
			contents: 'TBA';
			yourself ]! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 4/4/2009 15:54'!
root
	self rootPage
		addChild: self blog;
		addChild: self pcPage;
		addChild: self callPage;
		addChild: self datesPage;
		addChild: (self environmentPage
				addChild: self headerPage;
				addChild: self siteTitlePage;
				addChild: self footerPage;
				addChild: self menuPage;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self postTickerWidget;
				addChild: self blogArchiveWidget;
				addChild: self searchWidget;
				addChild: self poweredPage;
				addChild: self loggedInUserPage;
				addChild: self designChooserWidget;
				addChild: self eventTitlePage;
				yourself);
		addChild: self metaEnvironmentPage;
		addChild: self systemManagementPage.
	self rootPage localEnvironment: self environmentPage.
	self environmentPage localEnvironment: self metaEnvironmentPage.
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self systemManagementPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	self rootPage enumerator
		with;
		all;
		do: 
			[ :each | 
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self environmentPage.
	self makePrivate: self blogEnvironmentPage.
	self makePrivate: self metaEnvironmentPage.
	self makePrivate: self sitemapPage.
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	self makePrivate: self loggedInUserPage.
	^ self rootPage! !

!PREventDistribution methodsFor: 'as yet unclassified' stamp: 'tg 4/4/2009 16:44'!
stylesheetFile

	^ stylesheetFile ifNil: [
		stylesheetFile := (PRFile named: 'eventCss')
		filename: 'style.css';
		mimetype: 'text/css';
		contents: 
'.header h1.heading { font-size: 2em; padding-top: 1.5em; margin-bottom: 0; color: white;}
.header h2 { font-size: 1.2em; margin-top: 0; padding-bottom: 1.25em; color: white;}
.header {background: #545454; color: white;}
body {font-size: 11pt;}


/* HEADER */
.menu ul {
	margin: 0;
	margin-top: 0.2em;
	list-style-type: none;}
.menu ul li {
	display: inline;
	margin: 0;
	margin-right: 1.5em;
	list-style-type: none;}
.menu li a {
	padding-left: 1em;
	padding-right: 1em;
	padding-top: 0.5em;
	padding-bottom: 1em;}


/*BLOG*/
div.post {margin-bottom: 4.5em;}
div.comment {margin-bottom: 3em;}
.meta {font-size: 80%; color: #aaa;}
.leavecomment {margin-top: 4.5em; margin-bottom: 4.5em;}
.comments {margin-top: 4.5em;}


/* NAVIGATION */
.sidebar ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.sidebar ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.sidebar ul li {
	margin-top: 1.5em;}
.sidebar ul li a {
/*	padding-left: 0.3em;
	padding-right: 0.3em;
*/	padding-top: 0.3em;
	padding-bottom: 0.3em;}
.sidebar p,
.sidebar h1, .sidebar h2, .sidebar h3,
.sidebar .postticker .timestamp,
.sidebar .postticker .summary {}
.sidebar .active,
.menu li a.active {
	color: white;
	background: #ff6633;}


/*MAIN BODY*/
.mainbody {
	padding-top: 4em;
	padding-bottom: 15em;}
.postticker ul {
	list-style: none;
	margin-left: 0;}
.postticker ul li {
	margin-bottom: 1.5em;}
.postticker .timestamp {display: inline; padding-left: 1em; color: #aaa; font-size: 80%;}
.postticker .subscribe,
.postticker .timestamp .time,
.postticker .timestamp .author {display: none;}


/* FOOTER */
.footer {
	color: #aaa;
	font-size: 80%;
	text-align: left;}
.footer a { color: #aaa;}
.footer ul {list-style: none; margin-left: 0em;}
.footer ul ul {margin-left: 1.5em;}
.footer .commands ul, .footer .views ul {display: inline;}
.footer .commands ul li, .footer .views ul li {display: inline; padding-right: 1em;}


/* META */
.metaenvironment h1.heading {display: none;}
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}


/*DEFAULT*/
body {margin-top: 0;}
h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: inherit; }
h1 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
.maincontents {font-size: 1.5em;}
h2 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h3 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h4 { font-size: 1em; font-weight: bold; }
h5 { font-size: 1em; }
textarea {width: 100%;}


/* PIER */
.broken { color: red; font-weight: bold;}
.protected { color: #aaa; }
a {color: #ff6633;}
a:hover {
	color: white;
	background: #ff6633; }
a:hover.nobackground {background: white;}
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}
.right {text-align: right;}
.left {text-align: left;}
.center {text-align: center;}
.float {float: right;}
.nobullets ul {list-style: none; margin-left: 0;}
.nobullets ul li {list-style: none; margin-left: 0;}
th {background: #eee; font-weight: normal;}';
		yourself
	]! !

Object subclass: #PRLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Setup'!

!PRLoader class methodsFor: 'as yet unclassified' stamp: 'damiencassou 7/11/2009 10:50'!
load
	ScriptLoader loadLatestPackage: 'Gofer' from: 'http://source.lukas-renggli.ch/flair'.

	[ (Smalltalk at: #Gofer) new
		url: 'http://www.squeaksource.com/KomHttpServer';
			load: 'DynamicBindings';
			load: 'KomServices';
			load: 'KomHttpServer';
		url: 'http://www.squeaksource.com/Seaside';
			load: 'Seaside2.8a';
			load: 'Scriptaculous';
		url: 'http://www.squeaksource.com/rsrss';
			load: 'RSRSS2';
		url: 'http://source.lukas-renggli.ch/magritte';
			load: 'Magritte-Model';
			load: 'Magritte-Tests';
			load: 'Magritte-Seaside';
			load: 'Magritte-Morph';
		url: 'http://source.lukas-renggli.ch/pier';
			load: 'Pier-Model';
			load: 'Pier-Tests';
			load: 'Pier-Seaside';
			load: 'Pier-Blog';
			load: 'Pier-Security';
			load: 'Pier-Squeak-Persistency';
		url: 'http://source.lukas-renggli.ch/pieraddons';
			load: 'Pier-Design';
			load: 'Pier-Documents';
			load: 'Pier-EditorEnh';
			load: 'Pier-Google';
			load: 'Pier-Design';
			load: 'Pier-Links';
			load: 'Pier-Randomizer';
			load: 'Pier-TagCloud';
			load: 'Pier-Slideshow';
			load: 'Pier-Twitter';
			load: 'Pier-Setup';
			load: 'Pier-DesignChooser';
			load: 'Pier-SyntaxHighlighter';
		execute.
	] valueSupplyingAnswers: {
                        { 'username'. 'admin' }.
                        { 'password'. 'seaside' }.
                }.! !

!PRLoader class methodsFor: 'as yet unclassified' stamp: 'tg 7/11/2009 00:03'!
loadAndPrepareDistribution
	self loadTools.
	self load.
	self setProperPreferences.
	PRDistribution new register.
	Workspace new
		contents: PRDistribution workspaceText;
		openLabel: 'Pier'! !

!PRLoader class methodsFor: 'as yet unclassified' stamp: 'tg 7/10/2009 18:02'!
loadTools
	ScriptLoader loadLatestPackage: 'Gofer' from: 'http://source.lukas-renggli.ch/flair'.

	(Smalltalk at: #Gofer) new
		"AST"
		url: 'http://www.squeaksource.com/AST';
			load: 'AST-lr';
		"Refactoring"
		url: 'http://www.squeaksource.com/RefactoringEngine';
        		load: 'Refactoring-Core';
        		load: 'Refactoring-Spelling';
		"OmniBrowser"
		url: 'http://source.lukas-renggli.ch/omnibrowser';
			load: 'OmniBrowser';
			load: 'OB-Standard';
			load: 'OB-Morphic';
			load: 'OB-Refactory';
			load: 'OB-Regex';
			load: 'OB-Tools';
			load: 'OB-SUnitIntegration';
		"Tools"
		url: 'http://source.lukas-renggli.ch/unsorted';
			load: 'RFB';
			load: 'Shout';
			load: 'RoelTyper';
			load: 'ECompletion';
			load: 'ECompletionOmniBrowser';
		execute! !

!PRLoader class methodsFor: 'as yet unclassified' stamp: 'tg 7/11/2009 00:03'!
setProperPreferences

	| tinyFont codeFont baseFont boldFont |

	"Select Tools"
	ToolSet default: StandardToolSet.
	SystemBrowser default: OBSystemBrowserAdaptor.

	"Select Fonts"
	tinyFont := LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 8 stretchValue: 0 weightValue: 400 slantValue: 0.
	codeFont := LogicalFont familyName: 'DejaVu Sans Mono' fallbackFamilyNames: nil pointSize: 9 stretchValue: 0 weightValue: 400 slantValue: 0.
	baseFont := LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 10 stretchValue: 0 weightValue: 400 slantValue: 0.
	boldFont := LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 11 stretchValue: 0 weightValue: 600 slantValue: 0.

	Preferences setBalloonHelpFontTo: tinyFont.
	Preferences setButtonFontTo: baseFont.
	Preferences setCodeFontTo: codeFont.
	Preferences setHaloLabelFontTo: baseFont.
	Preferences setListFontTo: baseFont.
	Preferences setMenuFontTo: baseFont.
	Preferences setSystemFontTo: baseFont.
	Preferences setWindowTitleFontTo: boldFont.


	"Cleanup Environment"
	UIThemeStandardSqueak beCurrent.
	World submorphs do: [ :each |
	        each isSketchMorph
	                ifTrue: [ each delete ] ].

	"Set decent Preferences"
	Preferences enable: #scrollBarsNarrow.
	Preferences disable: #scrollBarsWithoutMenuButton.
	Preferences disable: #useNewDiffToolsForMC.! !
